SystemOrganization addCategory: #'tODE-Core'!

!Collection methodsFor: '*tode-core' stamp: 'dkh 5/22/2011 12:19'!
tODEInspectorFields
	<tODEInspectorFields>
	| i |
	i := 0.
	^ self asArray collect: [ :each | i := i + 1. i -> each ]! !

!Dictionary methodsFor: '*tode-core' stamp: 'dkh 5/22/2011 10:34'!
tODEInspectorFields
	<tODEInspectorFields>
	^ self associations! !

Notification subclass: #TOAbortCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

Object subclass: #TOObject
	instanceVariableNames: 'object properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:19'!
actualClass

	^self object class! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
object
	^ object! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
object: anObject
	object := anObject! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
properties

	properties ifNil: [ properties := Dictionary new ].
	^ properties! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
properties: anObject
	properties := anObject! !

!TOObject methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:15'!
renderControl: aBlock on: html
	| id |
	id := html nextId.
	html fieldSet: [
		html span: [
			aBlock
				value: id
				" update the paragraph "
				value: ((html jQuery this	
					parents: 'fieldset';
					find: 'p') load
						" serialize all nearby form elements "
						serialize: (html jQuery this		
							parents: 'span';
							find: ':input')) ]]! !

!TOObject methodsFor: 'render links' stamp: 'dkh 5/24/2011 01:15'!
renderLink: block with: labelRenderer on: html

	| id |
	id := html nextId.
	(html anchor)
		url: '#';
		id: id;
		onClick:
			(html jQuery ajax
				script: [ :s | block value: s ]);
		with: labelRenderer! !

TOObject subclass: #TOObjectFrame
	instanceVariableNames: 'selectedCenterTab centerTabSpec label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOObjectFrame methodsFor: 'private' stamp: 'dkh 5/23/2011 23:21'!
calculateCenterTabSpec
	| currentObject specs groups grouped ids |
	currentObject := self object.
	ids := IdentitySet new.
	specs := {self frameTabSpec} , ((Pragma allNamed: #tODECenterTabSpec from: currentObject class to: nil) reversed
		collect: [ :pragma | 
			(currentObject perform: pragma method selector)
				frame: self;
				yourself ]).
	specs
		select: [ :each | 
			(ids includes: each id)
				ifTrue: [ false ]
				ifFalse: [ 
					ids add: each id.
					true ] ].
	groups := (specs collect: [ :ea | ea group ]) asSet asSortedCollection: [ :a :b | a < b ].
	grouped := groups
		collect: [ :ea | (specs select: [ :b | b group = ea ]) asSortedCollection: [ :a :b | a order <= b order ] ].
	^ grouped gather: [ :ea | ea ]! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:50'!
centerTabSpec

	centerTabSpec ifNil: [ centerTabSpec := self calculateCenterTabSpec ].
	^centerTabSpec ! !

!TOObjectFrame methodsFor: 'private' stamp: 'dkh 5/23/2011 23:22'!
frameTabSpec

	^ (TOTabSpec new)
		id: #frame;
		receiver: self;
		frame: self;
		label: 'frame';
		order: 50;
		group: 'tODE';
		renderSelector: #renderFrameTabOn:frame:tOdeMain:! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:24'!
historyLabel

	^self object printStringLimitedTo: 50! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:43'!
label

	label ifNil: [ label := 'tODE frame'].
	^label! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:18'!
label: aString

	label := aString! !

!TOObjectFrame methodsFor: 'rendering' stamp: 'dkh 5/24/2011 00:02'!
renderFrame: index on: html main: main
	self
		renderLink: [ :s | 
			| frame |
			frame := main currentSpace push: self object.
			frame selectedCenterTab: self selectedCenterTab.
			main updateCenterSideHistory: s ]
		with: [ html strong: index printString , '. ' ]
		on: html.
	index == main historyIndex
		ifTrue: [ html strong: self historyLabel ]
		ifFalse: [ html text: self historyLabel ]! !

!TOObjectFrame methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:46'!
renderFrameTabOn: html frame: frame tOdeMain: main

	| members inspector |
	inspector := TOInspector new.
	html 
		break;
		strong: self label;
		text: ' for ', self historyLabel;
		break; break.
	inspector renderMembers: {'root'->TORoot current. 'frame'->self. 'object'->self object. 'main'->main.} on: html main: main.
	html break.
	html strong: 'frame properties:'.
	members := inspector fieldsFor: self properties.
	html unorderedList:  [ inspector renderMembers: members on: html main: main].
! !

!TOObjectFrame methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:23'!
renderObject: anObject on: html renderSelector: renderSelector main: main

	anObject
		perform: renderSelector
		withArguments:
			{html.
			self.
			main}! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTab

	^selectedCenterTab ! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTab: aSymbol

	^selectedCenterTab := aSymbol! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTabIndex
	| selectedTab |
	selectedTab := self selectedCenterTab.
	self centerTabSpec
		withIndexDo: [ :spec :i | 
			spec id == selectedTab
				ifTrue: [ ^ i - 1 ] ].
	^ 0! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:59'!
sidebarSpec
	| specs |
	specs := (self centerTabSpec at: self selectedCenterTabIndex + 1) sidebarSpec.
	specs do: [:spec | spec frame: self ].
	^specs! !

TOObject subclass: #TOView
	instanceVariableNames: 'frame ctlKeyPressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:16'!
frame
	^ frame! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:16'!
frame: anObject
	frame := anObject! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:25'!
renderClassHeading: aClass on: html main: main

	self renderSuperclassHeading: aClass on: html main: main.
! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/26/2011 13:53'!
renderSuperclassHeading: aClass on: html main: main
	self sharedClassState
		renderSuperclassHeading: aClass
		on: html
		main: main! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:25'!
selectedSuperclass
	^self sharedClassState selectedSuperclass! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:25'!
selectedSuperclass: anObject
	self sharedClassState selectedSuperclass: anObject! !

!TOView methodsFor: 'events' stamp: 'dkh 5/26/2011 13:47'!
selectedSuperclassChanged! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:31'!
sharedClassState
	^ self frame properties
		at: #sharedClassState
		ifAbsent: [ 
			self frame properties
				at: #sharedClassState
				put:
					((TOClassBasedBrowser new)
						object: self object;
						frame: self frame;
						yourself) ]! !

Object subclass: #TORoot
	instanceVariableNames: 'currentSpace'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'tODE-Core'!

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
current

	Current ifNil: [ Current := self new ].
	^Current ! !

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
reset
	"self reset"

	Current := nil! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:40'!
currentFrame

	^self currentSpace currentFrame! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:30'!
currentSpace 

	currentSpace ifNil: [ currentSpace := TOSpace new ].
	^currentSpace ! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:42'!
history
	^self currentSpace history! !

Object subclass: #TOSpace
	instanceVariableNames: 'currentFrame history historyIndex inverseFrameMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:22'!
currentFrame
	currentFrame
		ifNil: [ 
			| dict |
			dict := (Dictionary new)
				at: 1 put: 'string';
				at: #symbol put: 2;
				yourself.
			Smalltalk at: #WACounter ifPresent: [:cl | dict  at: 'counter' put: cl ].
			currentFrame := self push: dict ].
	^ currentFrame! !

!TOSpace methodsFor: 'private' stamp: 'dkh 5/22/2011 18:58'!
findFrameFor: anObject
	^self inverseFrameMap
		at: anObject
		ifAbsent: [ 
			self inverseFrameMap
				at: anObject
				put:
					(self newFrameFor: anObject) ].
! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:57'!
history
	
	history ifNil: [history := OrderedCollection new ].
	^history ! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:08'!
historyIndex

	^0! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 18:51'!
inverseFrameMap

	inverseFrameMap ifNil: [ inverseFrameMap := IdentityDictionary new ].
	^inverseFrameMap! !

!TOSpace methodsFor: 'private' stamp: 'dkh 5/22/2011 18:57'!
newFrameFor: anObject
	^ (TOObjectFrame new)
		object: anObject;
		yourself! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 19:02'!
push: anObject

	| frame |
	frame := self findFrameFor: anObject.
	self history addLast: frame.
	^currentFrame := frame! !

Object subclass: #TOTabSpec
	instanceVariableNames: 'id label group order priority renderSelector frame receiver sidebarSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:08'!
frame
	^ frame! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:08'!
frame: anObject
	frame := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:11'!
group
	^ group! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:11'!
group: anObject
	group := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
id
	^ id! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
id: anObject
	id := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
label
	^ label! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
label: anObject
	label := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:16'!
order
	^ order! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:16'!
order: anObject
	order := anObject! !

!TOTabSpec methodsFor: 'printing' stamp: 'dkh 5/26/2011 11:47'!
printOn: aStream

	super printOn: aStream.
	aStream 
		nextPut: $(;
		nextPutAll: self label;
		nextPut: $)! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:06'!
receiver
	^ receiver! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:06'!
receiver: anObject
	receiver := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:00'!
renderSelector
	^ renderSelector! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:00'!
renderSelector: anObject
	renderSelector := anObject! !

!TOTabSpec methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:09'!
renderTabSpecContentOn: html main: main
	self frame renderObject: self receiver on: html renderSelector:self renderSelector main: main! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:38'!
sidebarSpec
	sidebarSpec ifNil: [ ^#() ].
	^ sidebarSpec! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:38'!
sidebarSpec: anObject
	sidebarSpec := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:59'!
tabLabel
	
	label ifNil: [ ^self id asString ].
	^label! !
